import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopMerchant, ShopMerchantParam } from './model';

/**
 * 分页查询商户
 */
export async function pageShopMerchant(params: ShopMerchantParam) {
  const res = await request.get<ApiResult<PageResult<ShopMerchant>>>(
    '/shop/shop-merchant/page',
    params
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询商户列表
 */
export async function listShopMerchant(params?: ShopMerchantParam) {
  const res = await request.get<ApiResult<ShopMerchant[]>>(
    '/shop/shop-merchant',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加商户
 */
export async function addShopMerchant(data: ShopMerchant) {
  const res = await request.post<ApiResult<unknown>>(
    '/shop/shop-merchant',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改商户
 */
export async function updateShopMerchant(data: ShopMerchant) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/shop-merchant',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除商户
 */
export async function removeShopMerchant(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-merchant/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除商户
 */
export async function removeBatchShopMerchant(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-merchant/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询商户
 */
export async function getShopMerchant(id: number) {
  const res = await request.get<ApiResult<ShopMerchant>>(
    '/shop/shop-merchant/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
